package com.sincere.student.controller;

import com.sincere.student.dto.BaseDto;
import com.sincere.student.dto.IdDto;
import com.sincere.student.dto.yx.AddYxSchoolConsultVo;
import com.sincere.student.dto.yx.AddYxSchoolVo;
import com.sincere.student.dto.yx.CountYxSchoolConsult;
import com.sincere.student.dto.yx.QueryCountYxSchoolConsult;
import com.sincere.student.model.yx.SysYxSchool;
import com.sincere.student.model.yx.SysYxSchoolConsult;
import com.sincere.student.service.SysYxColumnService;
import com.sincere.student.utils.Page;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("sys/yx")
public class SysYxController {

    @Autowired
    SysYxColumnService sysYxColumnService;

    @ApiOperation("获取学校列表")
    @RequestMapping(value = "/schoolList", method = RequestMethod.POST)
    public BaseDto<Page<SysYxSchool>> schoolList(@RequestBody AddYxSchoolVo vo) {
        BaseDto<Page<SysYxSchool>> result = new BaseDto<>();
        result.setData(sysYxColumnService.schoolList(vo));
        return result;
    }

    @ApiOperation("添加学校")
    @PostMapping(value = "addSchool")
    public BaseDto addSchool(@RequestBody AddYxSchoolVo vo) {
        sysYxColumnService.addSchool(vo);
        return new BaseDto();
    }

    @ApiOperation("删除学校")
    @PostMapping(value = "delSchool")
    public BaseDto delSchool(@RequestBody IdDto idDto) {
        sysYxColumnService.delSchool(idDto.getId());
        return new BaseDto();
    }


    @ApiOperation("获取咨询列表")
    @RequestMapping(value = "/consultList", method = RequestMethod.POST)
    public BaseDto<Page<SysYxSchoolConsult>> consultList(@RequestBody AddYxSchoolConsultVo vo) {
        BaseDto<Page<SysYxSchoolConsult>> result = new BaseDto<>();
        result.setData(sysYxColumnService.consultList(vo));
        return result;
    }


    @ApiOperation("新建咨询会相关接口")
    @PostMapping(value = "/addConsult")
    public BaseDto createConsult(@RequestBody AddYxSchoolConsultVo schoolConsultVo) {
        BaseDto result = new BaseDto();
        sysYxColumnService.createConsult(schoolConsultVo);
        return result;
    }

    @ApiOperation("修改咨询会相关接口")
    @PostMapping(value = "/updateConsult")
    public BaseDto updateConsult(@RequestBody AddYxSchoolConsultVo schoolConsultVo) {
        BaseDto result = new BaseDto();
        sysYxColumnService.createConsult(schoolConsultVo);
        return result;
    }

    @ApiOperation("删除咨询会（传主键）")
    @PostMapping(value = "/delConsult")
    public BaseDto deleteConsult(@RequestBody IdDto idDto) {
        BaseDto result = new BaseDto();
        sysYxColumnService.delConsult(idDto.getId());
        return result;
    }

    @ApiOperation("获取详情")
    @PostMapping(value = "/getConsultDetail")
    public BaseDto getConsultDetail(@RequestBody IdDto idDto) {
        BaseDto result = new BaseDto();
        SysYxSchoolConsult consult = sysYxColumnService.getConsultDetail(idDto.getId());
        result.setData(consult);
        return result;
    }

    @ApiOperation("累加阅读量接口")
    @PostMapping(value = "/updateRead")
    public BaseDto updateRead(@RequestBody IdDto idDto) {
        BaseDto result = new BaseDto();
        sysYxColumnService.updateRead(idDto.getId());
        return result;
    }

    @ApiOperation("统计接口")
    @PostMapping(value = "/countNum")
    public BaseDto<Page<CountYxSchoolConsult>> updateRead(@RequestBody QueryCountYxSchoolConsult consult) {
        BaseDto<Page<CountYxSchoolConsult>> result = new BaseDto<>();
        result.setData(sysYxColumnService.countConsultList(consult));
        return result;
    }
}
