package com.sincere.student.service.impl;

import com.sincere.student.enums.AdvertEnums;
import com.sincere.student.mapper.AdvertMapper;
import com.sincere.student.model.Advert;
import com.sincere.student.service.AdvertService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AdvertServiceImpl implements AdvertService {

    @Autowired
    AdvertMapper advertMapper;

    @Override
    public Advert getScreen() {
        List<Advert> list = advertMapper.getList(AdvertEnums.screen.getType());
        if (list != null && list.size() > 0) {
            return list.get(0);
        } else {
            return null;
        }
    }

    @Override
    public List<Advert> getBanner() {
        return advertMapper.getList(AdvertEnums.banner.getType());
    }

    @Override
    public Advert getDetail(int id) {
        return advertMapper.getDetail(id);
    }

    @Override
    public Integer create(Advert advert) {
        return advertMapper.create(advert);
    }

    @Override
    public int delete(int id) {
        return advertMapper.delete(id);
    }

    @Override
    public int update(Advert advert) {
        return advertMapper.update(advert);
    }
}
