package com.sincere.student.service.impl;

import com.sincere.student.mapper.ParameterMapper;
import com.sincere.student.model.AccessToken;
import com.sincere.student.model.Parameter;
import com.sincere.student.service.ParameterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ParameterServiceImpl implements ParameterService {

    @Autowired
    ParameterMapper parameterMapper;

    @Override
    public Parameter getByCode(String code) {
        List<Parameter> list = parameterMapper.getByCode(code);
        if (list != null && list.size() > 0) {
            return list.get(0);
        }
        return null;
    }

    @Override
    public int create(Parameter parameter) {
        return parameterMapper.create(parameter);
    }

    @Override
    public int update(Parameter parameter) {
        return parameterMapper.update(parameter);
    }

    @Override
    public int insertAccessToken(AccessToken accessToken) {
        return parameterMapper.insertAccessToken(accessToken);
    }

    @Override
    public AccessToken getAccessToken() {
        return parameterMapper.getAccessToken();
    }

}
